﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using GRV11;

namespace TestGRV
{
    public partial class Form1 : Form
    {
        public GRExampleHandler1 mGRExampleHandler1;

        public Form1()
        {
            InitializeComponent();

            this.mGRExampleHandler1 = new GRExampleHandler1();
            this.mGRControl.OpenGLStarted += new GRControl.DelegateOpenGLStarted(this.mGRExampleHandler1.OpenGLStarted);
            this.mGRControl.KeyDown += new KeyEventHandler(this.mGRExampleHandler1.KeyDown);
            this.mGRControl.KeyUp += new KeyEventHandler(this.mGRExampleHandler1.KeyUp);
            this.mGRControl.MouseDown += new MouseEventHandler(this.mGRExampleHandler1.MouseDown);
            this.mGRControl.MouseUp += new MouseEventHandler(this.mGRExampleHandler1.MouseUp);
            this.mGRControl.MouseMove += new MouseEventHandler(this.mGRExampleHandler1.MouseMove);
            this.mGRControl.MouseWheel += new MouseEventHandler(this.mGRExampleHandler1.MouseWheel);
            this.mGRControl.Paint += new PaintEventHandler(this.mGRExampleHandler1.Paint);

            this.mTimer.Start();
            this.mGRControl.Focus();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            if (DesignMode == false)
            {
                this.mGRControl.Invalidate();
            }
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            this.mGRControl.Focus();
        }

        protected override bool ProcessDialogKey(Keys keyData)
        {
            if (
                (keyData == Keys.Up)
                || (keyData == Keys.Down)
                || (keyData == Keys.Left)
                || (keyData == Keys.Right))
            {
                KeyEventArgs e = new KeyEventArgs(keyData);
                this.mGRExampleHandler1.KeyDown(this.mGRControl, e);
                return (true);
            }

            return base.ProcessDialogKey(keyData);
        }
    }
}
